// Generated by CoffeeScript 1.12.7
var CustomDataTypeCommonFacet, CustomDataTypeWithCommons,
  bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CustomDataTypeWithCommons = (function(superClass) {
  extend(CustomDataTypeWithCommons, superClass);

  function CustomDataTypeWithCommons() {
    this.getQueryFieldBadge = bind(this.getQueryFieldBadge, this);
    return CustomDataTypeWithCommons.__super__.constructor.apply(this, arguments);
  }

  CustomDataTypeWithCommons.prototype.initData = function(data) {
    var cdata;
    if (!data[this.name()]) {
      cdata = {};
      data[this.name()] = cdata;
    } else {
      cdata = data[this.name()];
    }
    if (!cdata.url) {
      cdata.url = "";
    }
    return cdata;
  };

  CustomDataTypeWithCommons.prototype.renderFieldAsGroup = function() {
    return false;
  };

  CustomDataTypeWithCommons.prototype.renderRowAsBlock = function(data, top_level_data, opts) {
    return false;
  };

  CustomDataTypeWithCommons.prototype.getQueryFieldBadge = function(data) {
    var value;
    if (data[(this.name()) + ":unset"]) {
      value = $$("text.column.badge.without");
    } else {
      value = data[this.name()];
    }
    return {
      name: this.nameLocalized(),
      value: value
    };
  };

  CustomDataTypeWithCommons.prototype.supportsStandard = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.supportsPrinting = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.supportsFacet = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.getFacet = function(opts) {
    opts.field = this;
    return new CustomDataTypeCommonFacet(opts);
  };

  CustomDataTypeWithCommons.prototype.getSortFunction = function() {
    return (function(_this) {
      return function(a, b) {
        var ref, ref1;
        return CUI.util.compareIndex(((ref = a[_this.name()]) != null ? ref.conceptName : void 0) || 'zzz', ((ref1 = b[_this.name()]) != null ? ref1.conceptName : void 0) || 'zzz');
      };
    })(this);
  };

  CustomDataTypeWithCommons.prototype.hasRenderForSort = function() {
    return true;
  };

  CustomDataTypeWithCommons.prototype.sortExtraOpts = function() {
    return [
      {
        text: "conceptName",
        value: "conceptName"
      }, {
        text: "conceptURI",
        value: "conceptURI"
      }
    ];
  };

  CustomDataTypeWithCommons.prototype.renderSearchInput = function(data, opts) {
    var search_token;
    if (opts == null) {
      opts = {};
    }
    return search_token = new SearchToken({
      column: this,
      data: data,
      fields: opts.fields
    }).getInput().DOM;
  };

  CustomDataTypeWithCommons.prototype.getFieldNamesForSearch = function() {
    return this.getFieldNames();
  };

  CustomDataTypeWithCommons.prototype.getFieldNamesForSuggest = function() {
    return this.getFieldNames();
  };

  CustomDataTypeWithCommons.prototype.getFieldNames = function() {
    var field_names;
    field_names = [this.fullName() + ".conceptURI", this.fullName() + ".conceptName"];
    return field_names;
  };

  CustomDataTypeWithCommons.prototype.getSearchFilter = function(data, key) {
    var filter, phrase, ref, str, val;
    if (key == null) {
      key = this.name();
    }
    if (data[key + ":unset"]) {
      filter = {
        type: "in",
        fields: [this.fullName() + ".conceptName"],
        "in": [null]
      };
      filter._unnest = true;
      filter._unset_filter = true;
      return filter;
    }
    filter = CustomDataTypeWithCommons.__super__.getSearchFilter.call(this, data, key);
    if (filter) {
      return filter;
    }
    if (CUI.util.isEmpty(data[key])) {
      return;
    }
    val = data[key];
    ref = Search.getPhrase(val), str = ref[0], phrase = ref[1];
    switch (data[key + ":type"]) {
      case "token":
      case "fulltext":
      case void 0:
        filter = {
          type: "match",
          mode: data[key + ":mode"],
          fields: this.getFieldNamesForSearch(),
          string: str,
          phrase: phrase
        };
        break;
      case "field":
        filter = {
          type: "in",
          fields: this.getFieldNamesForSearch(),
          "in": [str]
        };
    }
    return filter;
  };

  CustomDataTypeWithCommons.prototype.renderEditorInput = function(data, top_level_data, opts) {
    var name;
    name = this.name();
    if (!data[name]) {
      data[name] = {
        conceptName: '',
        conceptURI: ''
      };
    }
    return this.__renderEditorInputPopover(data, data[name], opts);
  };

  CustomDataTypeWithCommons.prototype.__renderEditorInputPopover = function(data, cdata, opts) {
    var classNameForBurgerMenuButton, layout, that;
    if (opts == null) {
      opts = {};
    }
    that = this;
    layout;
    classNameForBurgerMenuButton = 'pluginDirectSelectEditSearch';
    if (ez5.version("6")) {
      classNameForBurgerMenuButton = 'pluginDirectSelectEditSearchFylr';
    } else if (ez5.version("5")) {
      classNameForBurgerMenuButton = 'pluginDirectSelectEditSearch';
    }
    layout = new CUI.HorizontalLayout({
      "class": 'customPluginEditorLayout',
      center: {
        "class": ''
      },
      right: {
        content: new CUI.Buttonbar({
          buttons: [
            new CUI.Button({
              text: '',
              icon: new CUI.Icon({
                "class": "fa-ellipsis-v"
              }),
              "class": classNameForBurgerMenuButton,
              onClick: (function(_this) {
                return function(e, dotsButton) {
                  var deleteClear, detailinfo, dotsButtonMenu, itemList, menu_items, uriCall;
                  dotsButtonMenu = new CUI.Menu({
                    "class": "customDataTypeCommonsMenu",
                    element: dotsButton
                  }, menu_items = [
                    {
                      text: $$('custom.data.type.commons.controls.search.label'),
                      value: 'search',
                      icon_left: new CUI.Icon({
                        "class": "fa-search"
                      }),
                      onClick: function(e2, btn2) {
                        that.showEditPopover(dotsButton, data, cdata, layout, opts);
                        return dotsButtonMenu.hide();
                      }
                    }
                  ], typeof that.__getAdditionalTooltipInfo === "function" ? (detailinfo = {
                    text: $$('custom.data.type.commons.controls.detailinfo.label'),
                    value: 'detail',
                    icon_left: new CUI.Icon({
                      "class": "fa-info-circle"
                    }),
                    disabled: that.isEmpty(data, 0, 0),
                    onClick: function(eDetailInfo, btnDetailInfo) {
                      var tooltip;
                      tooltip = new CUI.Tooltip({
                        element: btnDetailInfo,
                        placement: 'w',
                        markdown: true,
                        show_ms: 1000,
                        hide_ms: 200,
                        content: function(tooltip) {
                          var encodedURI, extendedInfo_xhr;
                          if (!that.isEmpty(data, 0, 0)) {
                            encodedURI = encodeURIComponent(cdata.conceptURI);
                            extendedInfo_xhr = {
                              "xhr": void 0
                            };
                            that.__getAdditionalTooltipInfo(encodedURI, tooltip, extendedInfo_xhr);
                            return new CUI.Label({
                              icon: "spinner",
                              text: $$('custom.data.type.commons.modal.form.popup.loadingstring')
                            });
                          }
                        }
                      });
                      tooltip.show();
                      return CUI.Events.listen({
                        type: ["click", "dblclick", "mouseout"],
                        capture: true,
                        node: btnDetailInfo,
                        only_once: true,
                        call: (function(_this) {
                          return function(ev) {
                            return dotsButtonMenu.hide();
                          };
                        })(this)
                      });
                    }
                  }, menu_items.push(detailinfo)) : void 0, uriCall = {
                    text: $$('custom.data.type.commons.controls.calluri.label'),
                    value: 'uri',
                    icon_left: new CUI.Icon({
                      "class": "fa-external-link"
                    }),
                    disabled: that.isEmpty(data, 0, 0) || !CUI.parseLocation(cdata.conceptURI),
                    onClick: function() {
                      window.open(cdata.conceptURI, "_blank");
                      return dotsButtonMenu.hide();
                    }
                  }, menu_items.push(uriCall), deleteClear = {
                    text: $$('custom.data.type.commons.controls.delete.label'),
                    value: 'delete',
                    name: 'deleteValueFromDANTEPlugin',
                    "class": 'deleteValueFromDANTEPlugin',
                    icon_left: new CUI.Icon({
                      "class": "fa-trash"
                    }),
                    disabled: that.isEmpty(data, 0, 0),
                    onClick: function() {
                      cdata = {
                        conceptName: '',
                        conceptURI: ''
                      };
                      data[that.name()] = cdata;
                      that.__updateResult(cdata, layout, opts);
                      return dotsButtonMenu.hide();
                    }
                  }, menu_items.push(deleteClear), itemList = {
                    items: menu_items
                  });
                  dotsButtonMenu._auto_close_after_click = false;
                  dotsButtonMenu.setItemList(itemList);
                  return dotsButtonMenu.show();
                };
              })(this)
            })
          ]
        })
      }
    });
    CUI.Events.registerEvent({
      type: "custom-deleteDataFromPlugin",
      bubble: false
    });
    CUI.Events.listen({
      type: "custom-deleteDataFromPlugin",
      instance: that,
      node: layout,
      call: (function(_this) {
        return function() {
          cdata = {};
          data[that.name()] = cdata;
          opts.deleteDataFromPlugin = true;
          return that.__updateResult(cdata, layout, opts);
        };
      })(this)
    });
    this.__updateResult(cdata, layout, opts);
    return layout;
  };

  CustomDataTypeWithCommons.prototype.showEditPopover = function(btn, data, cdata, layout, opts) {
    var cdata_form, searchsuggest_xhr, suggest_Menu, that;
    that = this;
    suggest_Menu;
    searchsuggest_xhr = {
      "xhr": void 0
    };
    cdata.countOfSuggestions = 50;
    cdata_form = new CUI.Form({
      "class": 'cdtFormWithPadding',
      data: cdata,
      fields: that.__getEditorFields(cdata),
      onDataChanged: (function(_this) {
        return function(data, elem) {
          _this.__updateResult(cdata, layout, opts);
          _this.__setEditorFieldStatus(cdata, layout);
          return _this.__updateSuggestionsMenu(cdata, cdata_form, data.searchbarInput, elem, suggest_Menu, searchsuggest_xhr, layout, opts);
        };
      })(this)
    }).start();
    suggest_Menu = new CUI.Menu({
      element: cdata_form.getFieldsByName("searchbarInput")[0],
      use_element_width_as_min_width: true,
      "class": "customDataTypeCommonsMenu"
    });
    return this.popover = new CUI.Popover({
      element: btn,
      placement: "wn",
      "class": "commonPlugin_Popover",
      pane: {
        header_left: new CUI.Label({
          text: $$('custom.data.type.commons.popover.choose.label')
        }),
        content: cdata_form
      }
    }).show();
  };

  CustomDataTypeWithCommons.prototype.isEmpty = function(data, top_level_data, opts) {
    var ref, ref1;
    if (opts == null) {
      opts = {};
    }
    if ((opts != null ? opts.mode : void 0) === "expert") {
      if (typeof data[this.name()] === 'object') {
        return CUI.util.isEmpty(data[this.name()] != null);
      } else {
        return CUI.util.isEmpty((ref = data[this.name()]) != null ? ref.trim() : void 0);
      }
    }
    return !((ref1 = data[this.name()]) != null ? ref1.conceptName : void 0);
  };

  CustomDataTypeWithCommons.prototype.getSaveData = function(data, save_data, opts) {
    var cdata, conceptFulltext, conceptNameChosenByHand, conceptStandard, frontendLanguage, frontendLanguages, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, that;
    that = this;
    if (opts.demo_data) {
      return {
        conceptName: 'Example',
        conceptURI: 'https://example.com'
      };
    }
    cdata = data[this.name()] || ((ref = data._template) != null ? ref[this.name()] : void 0);
    switch (this.getDataStatus(cdata)) {
      case "invalid":
        if (opts.copy) {
          return save_data[this.name()] = null;
        } else {
          throw new InvalidSaveDataException();
        }
        break;
      case "empty":
        return save_data[this.name()] = null;
      case "ok":
        conceptFulltext = {};
        if (cdata != null ? cdata._fulltext : void 0) {
          if ((ref1 = cdata._fulltext) != null ? ref1.string : void 0) {
            if (((ref2 = cdata._fulltext) != null ? ref2.string : void 0) !== '') {
              conceptFulltext.string = cdata._fulltext.string;
            }
          }
          if ((ref3 = cdata._fulltext) != null ? ref3.l10ntext : void 0) {
            if (cdata._fulltext.l10ntext) {
              conceptFulltext.l10ntext = cdata._fulltext.l10ntext;
            }
          }
          if ((ref4 = cdata._fulltext) != null ? ref4.text : void 0) {
            if (cdata._fulltext.text) {
              conceptFulltext.text = cdata._fulltext.text;
            }
          }
        } else {
          conceptFulltext.text = cdata.conceptName.trim();
        }
        conceptStandard = {};
        if (cdata != null ? cdata._standard : void 0) {
          if ((ref5 = cdata._standard) != null ? ref5.l10ntext : void 0) {
            if (cdata._standard.l10ntext) {
              conceptStandard.l10ntext = cdata._standard.l10ntext;
            }
          } else {
            if ((ref6 = cdata._standard) != null ? ref6.text : void 0) {
              if (((ref7 = cdata._standard) != null ? ref7.text : void 0) !== '') {
                conceptStandard.text = cdata._standard.text;
              }
            }
          }
        }
        frontendLanguages = ez5.loca.getLanguage();
        frontendLanguages = frontendLanguages.split('-');
        frontendLanguage = frontendLanguages[0];
        conceptNameChosenByHand = false;
        if (cdata != null ? cdata.conceptNameChosenByHand : void 0) {
          if (cdata.conceptNameChosenByHand === true) {
            conceptNameChosenByHand = true;
          }
        }
        save_data[this.name()] = {
          conceptName: cdata.conceptName.trim(),
          conceptURI: cdata.conceptURI.trim(),
          frontendLanguage: frontendLanguage,
          _fulltext: conceptFulltext,
          _standard: conceptStandard
        };
        if (cdata != null ? cdata.conceptAncestors : void 0) {
          if (cdata.conceptAncestors.length > 0) {
            if (Array.isArray(cdata.conceptAncestors)) {
              cdata.conceptAncestors = cdata.conceptAncestors.join(' ');
            }
            save_data[this.name()]['conceptAncestors'] = cdata.conceptAncestors;
          }
        }
        if (cdata != null ? cdata.conceptNameChosenByHand : void 0) {
          if (cdata.conceptNameChosenByHand === true) {
            save_data[this.name()]['conceptNameChosenByHand'] = true;
          }
        }
        if (cdata != null ? cdata.facetTerm : void 0) {
          return save_data[this.name()]['facetTerm'] = cdata.facetTerm;
        }
    }
  };

  CustomDataTypeWithCommons.prototype.__updateResult = function(cdata, layout, opts) {
    var displayURI, info, inputX, options, searchsuggest_xhr, suggest_Menu_directInput, that;
    that = this;
    if (opts.data) {
      opts.data[that.name(opts)] = cdata;
    }
    if (cdata != null ? cdata.conceptURI : void 0) {
      displayURI = cdata.conceptURI;
      if (displayURI.length > 20) {
        displayURI = displayURI.replace('http://', '');
        displayURI = displayURI.replace('https://', '');
      }
      if (displayURI.length > 30) {
        displayURI = displayURI.replace('uri.gbv.de/terminology/', '…/');
      }
      info = new CUI.VerticalLayout({
        "class": 'ez5-info_commonPlugin',
        top: {
          content: new CUI.Label({
            text: cdata.conceptName,
            multiline: true
          })
        },
        bottom: {
          content: new CUI.Button({
            name: "outputButtonHref",
            appearance: "flat",
            size: "normal",
            text: displayURI,
            tooltip: {
              markdown: true,
              placement: 'w',
              content: function(tooltip) {
                var encodedURI, extendedInfo_xhr;
                encodedURI = encodeURIComponent(cdata.conceptURI);
                extendedInfo_xhr = {
                  "xhr": void 0
                };
                if (typeof that.__getAdditionalTooltipInfo === "function") {
                  that.__getAdditionalTooltipInfo(encodedURI, tooltip, extendedInfo_xhr);
                  return new CUI.Label({
                    icon: "spinner",
                    text: $$('custom.data.type.commons.modal.form.popup.loadingstring')
                  });
                }
              }
            },
            onClick: (function(_this) {
              return function(evt, button) {
                return window.open(cdata.conceptURI, "_blank");
              };
            })(this)
          })
        }
      });
      layout.replace(info, 'center');
      layout.addClass('ez5-linked-object-edit');
      options = {
        "class": 'ez5-linked-object-container'
      };
      layout.__initPane(options, 'center');
    }
    if (!(cdata != null ? cdata.conceptURI : void 0)) {
      suggest_Menu_directInput;
      inputX = new CUI.Input({
        "class": "pluginDirectSelectEditInput",
        undo_and_changed_support: false,
        name: "directSelectInput",
        content_size: false,
        onKeyup: (function(_this) {
          return function(input) {
            var searchstring;
            searchstring = input.getValueForInput();
            if (typeof that.__updateSuggestionsMenu === "function") {
              return _this.__updateSuggestionsMenu(cdata, 0, searchstring, input, suggest_Menu_directInput, searchsuggest_xhr, layout, opts);
            }
          };
        })(this)
      });
      if (!(opts != null ? opts.callfrompoolmanager : void 0)) {
        inputX.render();
      }
      suggest_Menu_directInput = new CUI.Menu({
        element: inputX,
        use_element_width_as_min_width: true,
        "class": "customDataTypeCommonsMenu"
      });
      searchsuggest_xhr = {
        "xhr": void 0
      };
      layout.replace(inputX, 'center');
      layout.removeClass('ez5-linked-object-edit');
      options = {
        "class": ''
      };
      layout.__initPane(options, 'center');
    }
    if (!opts.deleteDataFromPlugin) {
      return that.__setEditorFieldStatus(cdata, layout);
    }
  };

  CustomDataTypeWithCommons.prototype.__setEditorFieldStatus = function(cdata, element) {
    switch (this.getDataStatus(cdata)) {
      case "invalid":
        element.addClass("cui-input-invalid");
        break;
      default:
        element.removeClass("cui-input-invalid");
    }
    CUI.Events.trigger({
      node: element,
      type: "editor-changed"
    });
    CUI.Events.trigger({
      node: element,
      type: "data-changed"
    });
    return this;
  };

  CustomDataTypeWithCommons.prototype.renderDetailOutput = function(data, top_level_data, opts) {
    return this.__renderButtonByData(data[this.name()]);
  };

  CustomDataTypeWithCommons.prototype.getDataStatus = function(cdata) {
    var nameCheck, uriCheck;
    if (cdata) {
      if (cdata.conceptURI && cdata.conceptName) {
        uriCheck = CUI.parseLocation(cdata.conceptURI);
        nameCheck = cdata.conceptName ? cdata.conceptName.trim() : void 0;
        if (uriCheck && nameCheck) {
          return "ok";
        }
        if (cdata.conceptURI.trim() === '' && cdata.conceptName.trim() === '') {
          return "empty";
        }
        return "invalid";
      }
    }
    return "empty";
  };

  return CustomDataTypeWithCommons;

})(CustomDataType);

CustomDataTypeCommonFacet = (function(superClass) {
  extend(CustomDataTypeCommonFacet, superClass);

  function CustomDataTypeCommonFacet() {
    return CustomDataTypeCommonFacet.__super__.constructor.apply(this, arguments);
  }

  CustomDataTypeCommonFacet.prototype.initOpts = function() {
    CustomDataTypeCommonFacet.__super__.initOpts.call(this);
    return this.addOpts({
      field: {
        mandatory: true,
        check: Field
      }
    });
  };

  CustomDataTypeCommonFacet.prototype.requestFacetWithLimit = function(obj) {
    return {
      limit: this.getLimit(),
      field: this._field.fullName() + ".conceptName",
      sort: "count",
      type: "term"
    };
  };

  CustomDataTypeCommonFacet.prototype.getObjects = function(key, data) {
    var ref;
    if (key == null) {
      key = this.name();
    }
    if (data == null) {
      data = this.data();
    }
    return ((ref = data[key]) != null ? ref.terms : void 0) || [];
  };

  CustomDataTypeCommonFacet.prototype.renderObjectText = function(object) {
    return object.term;
  };

  CustomDataTypeCommonFacet.prototype.getObjectPath = function(obj) {
    return [obj.term];
  };

  CustomDataTypeCommonFacet.prototype.name = function() {
    return this._field.fullName() + ".conceptName";
  };

  CustomDataTypeCommonFacet.prototype.requestSearchFilter = function(obj) {
    return {
      bool: "must",
      fields: [this._field.fullName() + ".conceptName"],
      type: "in",
      "in": [obj.term]
    };
  };

  return CustomDataTypeCommonFacet;

})(FieldFacet);
// Generated by CoffeeScript 1.12.7
var CustomDataTypeGoobi,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

ez5.session_ready((function(_this) {
  return function() {
    return ez5.pluginManager.getPlugin("custom-data-type-goobi").loadCss();
  };
})(this));

CustomDataTypeGoobi = (function(superClass) {
  extend(CustomDataTypeGoobi, superClass);

  function CustomDataTypeGoobi() {
    return CustomDataTypeGoobi.__super__.constructor.apply(this, arguments);
  }

  CustomDataTypeGoobi.prototype.getL10NPrefix = function() {
    return "custom.data.type.goobi";
  };

  CustomDataTypeGoobi.prototype.getCustomDataTypeName = function() {
    return "custom:base.custom-data-type-goobi.goobi";
  };

  CustomDataTypeGoobi.prototype.getCustomDataTypeNameLocalized = function() {
    return $$("custom.data.type.goobi.name");
  };

  CustomDataTypeGoobi.prototype.getFrontendLanguage = function() {
    var desiredLanguage;
    desiredLanguage = ez5.loca.getLanguage();
    desiredLanguage = desiredLanguage.split('-');
    desiredLanguage = desiredLanguage[0];
    return desiredLanguage;
  };

  CustomDataTypeGoobi.prototype.getDataStatus = function(cdata) {
    var nameCheck, uriCheck;
    if (cdata) {
      if (cdata.conceptURI && cdata.conceptName) {
        uriCheck = false;
        if (cdata.conceptURI.trim() !== '') {
          uriCheck = true;
        }
        nameCheck = cdata.conceptName ? cdata.conceptName.trim() : void 0;
        if (uriCheck && nameCheck) {
          return "ok";
        }
        if (cdata.conceptURI.trim() === '' && cdata.conceptName.trim() === '') {
          return "empty";
        }
        return "invalid";
      }
    }
    return "empty";
  };

  CustomDataTypeGoobi.prototype.__getAdditionalTooltipInfo = function(uri, tooltip, extendedInfo_xhr) {
    var goobi_api_url, goobi_endpoint_token, goobi_projects, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, that, url;
    that = this;
    if (extendedInfo_xhr.xhr !== void 0) {
      extendedInfo_xhr.xhr.abort();
    }
    goobi_endpoint_token = ((ref = that.getCustomMaskSettings().goobi_endpoint_token) != null ? ref.value : void 0) ? (ref1 = that.getCustomMaskSettings().goobi_endpoint_token) != null ? ref1.value : void 0 : '';
    goobi_endpoint_token = encodeURIComponent(goobi_endpoint_token);
    goobi_projects = ((ref2 = that.getCustomMaskSettings().projects) != null ? ref2.value : void 0) ? (ref3 = that.getCustomMaskSettings().projects) != null ? ref3.value : void 0 : '';
    goobi_projects = encodeURIComponent(goobi_projects);
    goobi_api_url = ((ref4 = that.getCustomMaskSettings().goobi_api_url) != null ? ref4.value : void 0) ? (ref5 = that.getCustomMaskSettings().goobi_api_url) != null ? ref5.value : void 0 : '';
    url = goobi_api_url + '/processes/search?token=' + goobi_endpoint_token + '&field=' + ((ref6 = that.getCustomSchemaSettings().safeAsConceptURI) != null ? ref6.value : void 0) + '&offset=0&orderby=' + ((ref7 = that.getCustomSchemaSettings().safeAsConceptURI) != null ? ref7.value : void 0) + '&descending=true&value=' + uri + '&limit=1&filterProjects=' + goobi_projects;
    extendedInfo_xhr.xhr = new CUI.XHR({
      url: url
    });
    extendedInfo_xhr.xhr.start().done(function(data, status, statusText) {
      var entry, htmlContent, j, k, key, key2, label, len, len1, metadata, metadatas, ref10, ref11, ref8, ref9, valuePairs;
      htmlContent = '<span style="font-weight: bold; padding: 3px 6px;">' + $$('custom.data.type.goobi.config.parameter.mask.infopopup.popup.info') + '</span>';
      htmlContent += '<table style="border-spacing: 10px; border-collapse: separate;">';
      if (data != null ? (ref8 = data[0]) != null ? ref8.metadata : void 0 : void 0) {
        metadatas = data != null ? (ref9 = data[0]) != null ? ref9.metadata : void 0 : void 0;
        valuePairs = {};
        for (key in metadatas) {
          metadata = metadatas[key];
          for (key2 = j = 0, len = metadata.length; j < len; key2 = ++j) {
            entry = metadata[key2];
            if (entry.labels) {
              if ((ref10 = entry.labels) != null ? ref10[that.getFrontendLanguage()] : void 0) {
                label = (ref11 = entry.labels) != null ? ref11[that.getFrontendLanguage()] : void 0;
              } else {
                label = entry.labels[Object.keys(entry.labels)[0]];
              }
              if (!valuePairs[label]) {
                valuePairs[label] = [];
              }
              valuePairs[label].push(entry['value']);
            }
          }
        }
        for (key in valuePairs) {
          metadata = valuePairs[key];
          htmlContent += '<tr><td style="min-width:150px;"><b>' + key + ':</b></td><td>';
          for (key2 = k = 0, len1 = metadata.length; k < len1; key2 = ++k) {
            entry = metadata[key2];
            htmlContent += entry;
          }
          htmlContent += '</td></tr>';
        }
        htmlContent += '</table>';
      }
      tooltip.DOM.innerHTML = htmlContent;
      return tooltip.autoSize();
    });
  };

  CustomDataTypeGoobi.prototype.__updateSuggestionsMenu = function(cdata, cdata_form, searchstring, input, suggest_Menu, searchsuggest_xhr, layout, opts) {
    var delayMillisseconds, that;
    that = this;
    delayMillisseconds = 200;
    return setTimeout((function() {
      var filter, filters, goobi_api_url, goobi_countSuggestions, goobi_endpoint_token, goobi_projects, goobi_projects_to_search, goobi_searchfield, goobi_searchfield_entry, goobi_searchterm, goobi_searchterms, j, k, key, l, len, len1, len2, metadataFilter, ref, ref1, ref2, ref3, ref4, ref5, ref6, ref7, ref8, ref9, safeAsConceptName, safeAsConceptURI, searchBody, url;
      safeAsConceptName = (ref = that.getCustomSchemaSettings().safeAsConceptName) != null ? ref.value : void 0;
      safeAsConceptURI = (ref1 = that.getCustomSchemaSettings().safeAsConceptURI) != null ? ref1.value : void 0;
      goobi_searchterm = searchstring.normalize('NFD').replace(/[\u0300-\u036f]/g, "");
      goobi_countSuggestions = 20;
      goobi_searchfield = (ref2 = that.getCustomMaskSettings().searchfields) != null ? ref2.value.split(',') : void 0;
      goobi_projects_to_search = (ref3 = that.getCustomMaskSettings().projects) != null ? ref3.value.split(',') : void 0;
      if (cdata_form) {
        goobi_searchterm = cdata_form.getFieldsByName("searchbarInput")[0].getValue();
        goobi_countSuggestions = cdata_form.getFieldsByName("countOfSuggestions")[0].getValue();
        goobi_searchfield = cdata_form.getFieldsByName("searchfieldSelect")[0].getValue();
      }
      if (goobi_searchterm.length === 0) {
        return;
      } else {
        goobi_searchterms = goobi_searchterm.split(' ');
      }
      if (searchsuggest_xhr.xhr !== void 0) {
        searchsuggest_xhr.xhr.abort();
      }
      searchBody = {};
      searchBody['filterProjects'] = goobi_projects_to_search;
      searchBody['metadataFilters'] = [];
      if (!Array.isArray(goobi_searchfield)) {
        goobi_searchfield = [goobi_searchfield];
      }
      for (key = j = 0, len = goobi_searchterms.length; j < len; key = ++j) {
        goobi_searchterm = goobi_searchterms[key];
        filters = [];
        for (key = k = 0, len1 = goobi_searchfield.length; k < len1; key = ++k) {
          goobi_searchfield_entry = goobi_searchfield[key];
          filter = {
            "field": goobi_searchfield_entry,
            "relation": "LIKE",
            "value": goobi_searchterm
          };
          filters.push(filter);
        }
        metadataFilter = {
          "conjunctive": false,
          "filters": filters
        };
        searchBody['metadataFilters'].push(metadataFilter);
      }
      searchBody['metadataConjunctive'] = true;
      searchBody['sortField'] = goobi_searchfield.shift();
      searchBody['sortDescending'] = false;
      searchBody['limit'] = goobi_countSuggestions;
      searchBody['offset'] = '0';
      searchBody['wantedFields'] = [safeAsConceptName, safeAsConceptURI];
      for (key = l = 0, len2 = goobi_searchfield.length; l < len2; key = ++l) {
        goobi_searchfield_entry = goobi_searchfield[key];
        searchBody['wantedFields'].push(goobi_searchfield_entry);
      }
      searchBody['wantedFields'] = searchBody['wantedFields'].filter((function(_this) {
        return function(x, i, a) {
          return a.indexOf(x) === i;
        };
      })(this));
      searchBody = JSON.stringify(searchBody);
      goobi_endpoint_token = ((ref4 = that.getCustomMaskSettings().goobi_endpoint_token) != null ? ref4.value : void 0) ? (ref5 = that.getCustomMaskSettings().goobi_endpoint_token) != null ? ref5.value : void 0 : '';
      goobi_endpoint_token = encodeURIComponent(goobi_endpoint_token);
      goobi_projects = ((ref6 = that.getCustomMaskSettings().projects) != null ? ref6.value : void 0) ? (ref7 = that.getCustomMaskSettings().projects) != null ? ref7.value : void 0 : '';
      goobi_projects = encodeURIComponent(goobi_projects);
      goobi_api_url = ((ref8 = that.getCustomMaskSettings().goobi_api_url) != null ? ref8.value : void 0) ? (ref9 = that.getCustomMaskSettings().goobi_api_url) != null ? ref9.value : void 0 : '';
      url = goobi_api_url + '/processes/search?token=' + goobi_endpoint_token;
      searchsuggest_xhr.xhr = new CUI.XHR({
        method: 'POST',
        url: url,
        body: searchBody,
        headers: {
          'content-type': 'application/json'
        }
      });
      return searchsuggest_xhr.xhr.start().done(function(data, status, statusText) {
        var conceptNameCandidate, conceptURICandidate, extendedInfo_xhr, id, itemList, len3, m, menu_items, suggestion;
        if (status === 200 && data) {
          extendedInfo_xhr = {
            "xhr": void 0
          };
          menu_items = [];
          for (key = m = 0, len3 = data.length; m < len3; key = ++m) {
            suggestion = data[key];
            id = suggestion.id;
            suggestion = suggestion.metadata;
            if (suggestion != null ? suggestion[safeAsConceptURI] : void 0) {
              conceptNameCandidate = (suggestion != null ? suggestion[safeAsConceptName] : void 0) ? suggestion != null ? suggestion[safeAsConceptName][0].value : void 0 : '';
              conceptURICandidate = (suggestion != null ? suggestion[safeAsConceptURI] : void 0) ? suggestion != null ? suggestion[safeAsConceptURI][0].value : void 0 : '';
              if (conceptNameCandidate === '') {
                conceptNameCandidate = $$('custom.data.type.goobi.config.parameter.mask.notdefined.label') + ' (ID: ' + id + ')';
              }
              if (conceptNameCandidate !== '' && conceptURICandidate !== '') {
                (function(key) {
                  var getUri, item;
                  getUri = conceptURICandidate;
                  item = {
                    text: conceptNameCandidate,
                    value: conceptURICandidate,
                    tooltip: {
                      markdown: true,
                      placement: "nw",
                      content: function(tooltip) {
                        that.__getAdditionalTooltipInfo(getUri, tooltip, extendedInfo_xhr);
                        return new CUI.Label({
                          icon: "spinner",
                          text: $$('custom.data.type.goobi.config.parameter.mask.show_infopopup.loading.label')
                        });
                      }
                    }
                  };
                  return menu_items.push(item);
                })(key);
              }
            }
          }
          itemList = {
            onClick: function(ev2, btn) {
              cdata.conceptURI = btn.getOpt("value");
              cdata.conceptName = btn.getText();
              console.error(cdata);
              console.error(opts);
              that.__updateResult(cdata, layout, opts);
              suggest_Menu.hide();
              if (that.popover) {
                return that.popover.hide();
              }
            },
            items: menu_items
          };
          if (itemList.items.length === 0) {
            itemList = {
              items: [
                {
                  text: "kein Treffer",
                  value: void 0
                }
              ]
            };
          }
          suggest_Menu.setItemList(itemList);
          return suggest_Menu.show();
        }
      });
    }), delayMillisseconds);
  };

  CustomDataTypeGoobi.prototype.__getEditorFields = function(cdata) {
    var fields, j, key, len, option, ref, searchOptions, searchfield, searchfields;
    searchOptions = [];
    searchfields = (ref = this.getCustomMaskSettings().searchfields) != null ? ref.value.split(',') : void 0;
    for (key = j = 0, len = searchfields.length; j < len; key = ++j) {
      searchfield = searchfields[key];
      option = {
        value: searchfield,
        text: $$('custom.data.type.goobi.modal.form.text.searchfield.' + searchfield)
      };
      searchOptions.push(option);
    }
    fields = [
      {
        type: CUI.Select,
        "class": "commonPlugin_Select",
        undo_and_changed_support: false,
        form: {
          label: $$('custom.data.type.goobi.modal.form.text.count')
        },
        options: [
          {
            value: 10,
            text: '10 ' + $$('custom.data.type.goobi.modal.form.text.count_short')
          }, {
            value: 20,
            text: '20 ' + $$('custom.data.type.goobi.modal.form.text.count_short')
          }, {
            value: 50,
            text: '50 ' + $$('custom.data.type.goobi.modal.form.text.count_short')
          }, {
            value: 100,
            text: '100 ' + $$('custom.data.type.goobi.modal.form.text.count_short')
          }, {
            value: 500,
            text: '500 ' + $$('custom.data.type.goobi.modal.form.text.count_short')
          }
        ],
        name: 'countOfSuggestions'
      }, {
        type: CUI.Select,
        "class": "commonPlugin_Select",
        undo_and_changed_support: false,
        form: {
          label: $$('custom.data.type.goobi.modal.form.text.searchfield')
        },
        options: searchOptions,
        name: 'searchfieldSelect'
      }, {
        type: CUI.Input,
        "class": "commonPlugin_Input",
        undo_and_changed_support: false,
        form: {
          label: $$("custom.data.type.goobi.modal.form.text.searchbar")
        },
        placeholder: $$("custom.data.type.goobi.modal.form.text.searchbar.placeholder"),
        name: "searchbarInput"
      }
    ];
    return fields;
  };

  CustomDataTypeGoobi.prototype.__renderButtonByData = function(cdata) {
    var extendedInfo_xhr, that;
    that = this;
    switch (this.getDataStatus(cdata)) {
      case "empty":
        return new CUI.EmptyLabel({
          text: $$("custom.data.type.goobi.edit.no_goobi")
        }).DOM;
      case "invalid":
        return new CUI.EmptyLabel({
          text: $$("custom.data.type.goobi.edit.no_valid_goobi")
        }).DOM;
    }
    extendedInfo_xhr = {
      "xhr": void 0
    };
    cdata.conceptURI = cdata.conceptURI;
    return new CUI.HorizontalLayout({
      maximize: true,
      left: {
        content: new CUI.Label({
          centered: false,
          text: cdata.conceptName
        })
      },
      center: {
        content: new CUI.Button({
          appearance: "link",
          icon_left: new CUI.Icon({
            "class": "fa-info-circle"
          }),
          tooltip: {
            markdown: true,
            placement: 'n',
            content: function(tooltip) {
              var uri;
              uri = cdata.conceptURI;
              that.__getAdditionalTooltipInfo(uri, tooltip, extendedInfo_xhr);
              return new CUI.Label({
                icon: "spinner",
                text: $$('custom.data.type.dante.modal.form.popup.loadingstring')
              });
            }
          },
          text: ""
        })
      },
      right: null
    }).DOM;
  };

  CustomDataTypeGoobi.prototype.getCustomDataOptionsInDatamodelInfo = function(custom_settings) {
    this;
    var ref, tags;
    tags = [];
    if ((ref = custom_settings.safeAsConceptName) != null ? ref.value : void 0) {
      tags.push("✓ Name: " + custom_settings.safeAsConceptName.value);
    } else {
      tags.push("✘ " + $$('custom.data.type.goobi.missing.config'));
    }
    if (custom_settings.safeAsConceptURI.value) {
      tags.push("✓ URI: " + custom_settings.safeAsConceptURI.value);
    } else {
      tags.push("✘ " + $$('custom.data.type.goobi.missing.config'));
    }
    return tags;
  };

  return CustomDataTypeGoobi;

})(CustomDataTypeWithCommons);

CustomDataType.register(CustomDataTypeGoobi);
