// Generated by CoffeeScript 1.12.7
var AdminEventManager,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AdminEventManager = (function(superClass) {
  extend(AdminEventManager, superClass);

  function AdminEventManager() {
    return AdminEventManager.__super__.constructor.apply(this, arguments);
  }

  AdminEventManager.is_allowed = function() {
    return ez5.session.hasSystemRight("root", "plugin.eventmanager.manager");
  };

  AdminEventManager.group = function() {
    return "zze_administration";
  };

  AdminEventManager.submenu = function() {
    return "administration";
  };

  AdminEventManager.path = function() {
    return ["eventmanager"];
  };

  AdminEventManager.label = function() {
    return "admin.event.manager.menu.label";
  };

  AdminEventManager.prototype.initOpts = function(opts) {
    if (ez5.version("6")) {
      this.__newApi = true;
    } else {
      this.__newApi = false;
    }
    return AdminEventManager.__super__.initOpts.call(this, opts);
  };

  AdminEventManager.prototype.getTreeOpts = function() {
    var columnClasses, columnKeys, filter, i, key, len, opts;
    opts = AdminEventManager.__super__.getTreeOpts.call(this);
    opts.filterManager = function() {};
    filter = new CUI.ListViewHeaderRow();
    this.__sortColumns = [];
    columnClasses = [];
    columnKeys = ["_id", "timestamp", "user_generated_displayname", "type", "type_key"];
    for (i = 0, len = columnKeys.length; i < len; i++) {
      key = columnKeys[i];
      filter.addColumn(this.getHeaderColumn(key));
      columnClasses.push("ez5-admin-event-manager-column-" + key);
    }
    opts.colClasses = columnClasses;
    opts.extra_header = filter;
    this.__sort = "_id.DESC";
    this.__updateSortButtons();
    opts.cols = ["auto", "auto", "auto", "auto", "auto"];
    opts.selectableRows = "multiple";
    return opts;
  };

  AdminEventManager.prototype.loadInternal = function() {
    AdminEventManager.__super__.loadInternal.call(this);
    this.__layout.replace(new CUI.SimplePane({
      "class": "cui-pane--window",
      title: $$("admin.event.manager.title"),
      content: this.tree.render()
    }), "center");
    return this;
  };

  AdminEventManager.prototype.readOpts = function() {
    AdminEventManager.__super__.readOpts.call(this);
    return this.__filter_data = {};
  };

  AdminEventManager.prototype.getRightPane = function() {
    return {
      content: {},
      flexHandle: {
        label: this.getMenuTitle(),
        state_name: "admin-manager-right",
        hidden: false
      }
    };
  };

  AdminEventManager.prototype.getContainer = function() {
    return this.__layout.right();
  };

  AdminEventManager.prototype.getEvents = function() {
    var events, ref;
    events = ((ref = ez5.session.getDefaults().server.events) != null ? ref.searchable_events.slice(0) : void 0) || [];
    return events.sort(function(a, b) {
      return a.localeCompare(b);
    });
  };

  AdminEventManager.prototype.getTreePaneContent = function() {
    var groupData, groupOptions, i, len, ref, ref1, sp, tpc, userGroupSelector, userType, userTypesOptions, userTypesOptionsField, vl;
    groupOptions = [];
    groupData = {};
    this.__searchIdInput = new CUI.Input({
      maximize_horizontal: true,
      name: "id",
      placeholder: this.__newApi ? $$("admin.event.manager.form.id.placeholder") : void 0,
      form: {
        label: $$("admin.event.manager.form.id")
      }
    });
    userTypesOptions = [];
    this.__filter_form = new CUI.Form({
      data: this.__filter_data,
      padded: true,
      onDataChanged: this.__enableDisableFormFields,
      fields: [
        this.__searchIdInput, this.getSelectFilter("type", this.getEvents()), {
          maximize_horizontal: true,
          type: CUI.DateTime,
          ui: "admin-event-manager-form-date-from-datetime",
          undo_and_changed_support: false,
          form: {
            label: $$("admin.event.manager.form.date_from")
          },
          name: "from",
          display_type: "short",
          input_types: ["date_time"]
        }, {
          maximize_horizontal: true,
          type: CUI.DateTime,
          ui: "admin-event-manager-form-date-to-datetime",
          undo_and_changed_support: false,
          form: {
            label: $$("admin.event.manager.form.date_to")
          },
          name: "to",
          display_type: "short",
          input_types: ["date_time"]
        }, ez5.version("6.7") ? {
          maximize_horizontal: true,
          type: CUI.Input,
          name: "system_object_id",
          form: {
            label: $$("admin.event.manager.form.system_object_id")
          },
          placeholder: $$("admin.event.manager.form.system_object_id.placeholder")
        } : void 0, ez5.version("6.7") ? {
          type: ez5.ObjecttypeSelector,
          form: {
            label: $$("admin.event.manager.form.objecttype")
          },
          name: "objecttype",
          show_name: true,
          store_value: "fullname"
        } : void 0, new CUI.Options({
          maximize_horizontal: true,
          placeholder: "",
          form: {
            label: $$("admin.event.manager.form.user_types")
          },
          name: "userTypes",
          options: userTypesOptions
        }), new CUI.Options({
          maximize_horizontal: true,
          placeholder: "",
          name: "groups",
          options: groupOptions
        }), new UserGroupSelector({
          maximize_horizontal: true,
          form: {
            label: $$("admin.event.manager.form.id_user")
          },
          name: "user",
          aclWhoManager: new AclWhoManager({
            who_filter: ["user"]
          })
        }), userGroupSelector = new UserGroupSelector({
          maximize_horizontal: true,
          form: {
            label: $$("admin.event.manager.form.id_group")
          },
          aclWhoManager: new AclWhoManager({
            store_full_data: true,
            filter_groups: ["system"],
            who_filter: ["group"]
          }),
          name: "group",
          data: groupData,
          onDataChanged: (function(_this) {
            return function() {
              var group, idGroup;
              group = groupData.group;
              if (!group) {
                return;
              }
              group = Group.newInstance({
                group: group
              });
              idGroup = group.getId();
              if (CUI.util.idxInArray(null, groupOptions, (function(v) {
                return v.value === idGroup;
              })) === -1) {
                groupOptions.push({
                  value: idGroup,
                  text: group.getDisplayText()
                });
              }
              userGroupSelector.setValue();
              CUI.util.pushOntoArray(idGroup, _this.__filter_data.groups);
              return _this.__filter_form.getFieldsByName("groups")[0].reload();
            };
          })(this)
        }), new CUI.Options({
          maximize_horizontal: true,
          placeholder: "",
          name: "groups",
          options: groupOptions
        })
      ]
    }).start();
    ref1 = ((ref = ez5.session.getDefaults().server.events) != null ? ref.searchable_event_user_types : void 0) || [];
    for (i = 0, len = ref1.length; i < len; i++) {
      userType = ref1[i];
      userTypesOptions.push({
        text: userType
      });
    }
    userTypesOptionsField = this.__filter_form.getFieldsByName("userTypes")[0];
    userTypesOptionsField.reload();
    this.__empty_filter_data = CUI.util.copyObject(this.__filter_data, true);
    sp = new CUI.SimplePane({
      content: this.__filter_form,
      footer_left: (function(_this) {
        return function() {
          return _this.getMoreButtons();
        };
      })(this),
      footer_right: (function(_this) {
        return function() {
          var buttons;
          buttons = [
            {
              ui: "admin-event-manager-form-reset-button",
              loca_key: "admin.event.manager.form.button.reset",
              onClick: function() {
                _this.__resetFilters();
              }
            }, {
              ui: "admin-event-manager-form-refresh-button",
              loca_key: "admin.event.manager.form.button.go",
              primary: true,
              onClick: function() {
                _this.__refresh();
              }
            }
          ];
          return buttons;
        };
      })(this)
    });
    return sp;
    tpc = AdminEventManager.__super__.getTreePaneContent.call(this);
    vl = new CUI.VerticalLayout({
      maximize: true,
      top: {
        content: sp
      },
      center: {
        content: tpc
      }
    });
    return vl;
  };

  AdminEventManager.prototype.__resetFilters = function() {
    this.__filter_data = CUI.util.copyObject(this.__empty_filter_data, true);
    this.data = null;
    this.load();
  };

  AdminEventManager.prototype.__refresh = function() {
    var wb;
    wb = new CUI.WaitBlock({
      element: this.getTree()
    }).show();
    return this.loadTree(true).always((function(_this) {
      return function() {
        return wb.destroy();
      };
    })(this));
  };

  AdminEventManager.prototype.__updateSortButtons = function() {
    var i, len, ref, ref1, sc, sort_sc;
    ref = this.__sortColumns;
    for (i = 0, len = ref.length; i < len; i++) {
      sc = ref[i];
      if ((ref1 = this.__sort) != null ? ref1.startsWith(sc.key) : void 0) {
        sort_sc = sc;
      } else {
        sc.button.replace(new CUI.Icon(), "right");
      }
    }
    if (!sort_sc) {
      return;
    }
    if (this.__sort.match(/DESC$/)) {
      sort_sc.button.replace(new CUI.Icon({
        icon: "south"
      }), "right");
    } else {
      sort_sc.button.replace(new CUI.Icon({
        icon: "north"
      }), "right");
    }
    return this;
  };

  AdminEventManager.prototype.getHeaderColumn = function(key) {
    var sb;
    if (key === "type") {
      return new CUI.ListViewHeaderColumn({
        element: new LocaLabel({
          loca_key: "admin.event.manager.column." + key,
          right: true
        })
      });
    }
    sb = new LocaButton({
      loca_key: "admin.event.manager.column." + key,
      appearance: "link",
      right: true,
      onClick: (function(_this) {
        return function() {
          if (!_this.__sort || !_this.__sort.startsWith(key)) {
            _this.__sort = key + ".DESC";
          } else if (_this.__sort.endsWith("DESC")) {
            _this.__sort = key + ".ASC";
          } else {
            _this.__sort = "_id.DESC";
          }
          _this.__updateSortButtons();
          return _this.loadTree(true);
        };
      })(this)
    });
    if (key === "type_key") {
      key = "type";
    }
    this.__sortColumns.push({
      button: sb,
      key: key
    });
    return new CUI.ListViewHeaderColumn({
      element: sb
    });
  };

  AdminEventManager.locaType = function(k) {
    return ez5.loca.str_default('admin.event.manager.event.' + k.toLowerCase(), k);
  };

  AdminEventManager.prototype.getSelectFilter = function(key, keys) {
    var i, len, option, options, opts;
    opts = [];
    options = keys.map(function(key) {
      return {
        value: key,
        text: AdminEventManager.locaType(key)
      };
    });
    options.sort(function(optionOne, optionTwo) {
      return optionOne.text.localeCompare(optionTwo.text);
    });
    for (i = 0, len = options.length; i < len; i++) {
      option = options[i];
      opts.push({
        ui: "admin-event-manager-" + option.value + "-select-option",
        value: option.value,
        content: new CUI.VerticalList({
          content: [
            new CUI.Label({
              "class": "ez5-event-option-label",
              text: option.text
            }), new CUI.Label({
              text: option.value,
              appearance: "secondary",
              size: "mini"
            })
          ]
        })
      });
    }
    return {
      type: CUI.FormPopover,
      maximize_horizontal: true,
      ui: "admin-event-manager-type-form-select",
      popover: {
        "class": "ez5-admin-event-manager-select",
        use_element_width_as_min_width: true,
        pointer: null,
        placements: ["se"],
        pane: {
          padded: true
        },
        placement: "se"
      },
      form: {
        label: $$("admin.event.manager.form." + key)
      },
      button: {
        "class": "ez5-admin-event-manager-select cui-button--has-caret",
        text: $$("admin.event.manager.select.button"),
        icon_right: "fa-angle-down"
      },
      renderDisplayContent: (function(_this) {
        return function() {
          var div, eventType, j, len1, ref, ref1;
          if (!((ref = _this.__filter_data[key]) != null ? ref.length : void 0)) {
            return;
          }
          div = CUI.dom.element("DIV", {
            "class": "ez5-tag-holder"
          });
          ref1 = _this.__filter_data[key];
          for (j = 0, len1 = ref1.length; j < len1; j++) {
            eventType = ref1[j];
            div.appendChild(new CUI.Label({
              "class": "ez5-tag",
              text: AdminEventManager.locaType(eventType) + (" [" + eventType + "]")
            }).DOM);
          }
          return div;
        };
      })(this),
      fields: [
        {
          type: CUI.Options,
          horizontal: false,
          name: key,
          options: opts
        }
      ]
    };
  };

  AdminEventManager.prototype.getMissingName = function() {
    return $$("admin.event.manager.missing_name");
  };

  AdminEventManager.prototype.getLeftTitle = function() {
    return $$("admin.event.manager.search.title");
  };

  AdminEventManager.prototype.getCenterTitle = function() {
    return $$("admin.event.manager.pane_title");
  };

  AdminEventManager.prototype.getMenuTitle = function() {
    return new CUI.Label({
      text: $$("admin.event.manager.title")
    });
  };

  AdminEventManager.prototype.getListFields = function() {};

  AdminEventManager.prototype.getTitle = function() {
    return new CUI.Label({
      text: $$("admin.event.manager.pane_title")
    });
  };

  AdminEventManager.prototype.loadList = function(filter, opts) {
    var dfr, searchCallback, searchOpts;
    if (opts == null) {
      opts = {};
    }
    if (opts.searchOpts) {
      searchOpts = opts.searchOpts;
    } else {
      searchOpts = {};
    }
    searchOpts = this.__getSearchOpts(searchOpts);
    dfr = new CUI.Deferred();
    searchCallback = (function(_this) {
      return function(data) {
        var _data, event, events, i, len, ref, ref1, ref2;
        if (CUI.util.isEmpty(data)) {
          dfr.reject();
          return;
        }
        if (data.offset == null) {
          data.offset = 0;
        }
        events = [];
        ref = data.objects;
        for (i = 0, len = ref.length; i < len; i++) {
          event = ref[i];
          events.push(new AdminEventManagerEvent({
            event: event,
            manager: _this
          }));
        }
        if (events.length > 0) {
          _this.__csvButton.enable();
          if ((ref1 = _this.__deleteButton) != null) {
            ref1.enable();
          }
        } else {
          _this.__csvButton.disable();
          if ((ref2 = _this.__deleteButton) != null) {
            ref2.disable();
          }
        }
        _data = {
          count: data.count,
          offset: data.offset,
          limit: data.limit,
          objects: data
        };
        _this.__count = data.count;
        return dfr.resolve(events, _data);
      };
    })(this);
    ez5.splash.show("admin.event.manager.splash.loading-events");
    if (this.__newApi || CUI.util.isEmpty(this.__filter_data.id)) {
      ez5.api.event({
        api: "/list",
        data: searchOpts
      }).done(searchCallback).fail(dfr.reject);
    } else {
      ez5.api.event({
        api: "/" + this.__filter_data.id
      }).done((function(_this) {
        return function(data) {
          var ref;
          data = {
            objects: [data],
            count: 1,
            limit: 1
          };
          searchCallback(data);
          _this.__csvButton.disable();
          return (ref = _this.__deleteButton) != null ? ref.disable() : void 0;
        };
      })(this)).fail((function(_this) {
        return function() {
          var data;
          data = {
            objects: [],
            count: 0,
            limit: 1
          };
          return searchCallback(data);
        };
      })(this));
    }
    dfr.always((function(_this) {
      return function() {
        return ez5.splash.hide();
      };
    })(this));
    return dfr.promise();
  };

  AdminEventManager.prototype.__getSearchOpts = function(searchOpts) {
    var ref;
    if (searchOpts == null) {
      searchOpts = {};
    }
    if (!searchOpts.limit) {
      searchOpts.limit = 100;
    }
    if (!searchOpts.offset) {
      searchOpts.offset = 0;
    }
    if (this.__newApi && !CUI.util.isEmpty(this.__filter_data.id)) {
      searchOpts.id = this.__filter_data.id;
    }
    if (((ref = this.__filter_data.type) != null ? ref.length : void 0) > 0) {
      searchOpts.type = this.__filter_data.type.join(",");
    }
    if (!CUI.util.isEmpty(this.__filter_data.from)) {
      searchOpts.date_from = this.__filter_data.from;
    }
    if (!CUI.util.isEmpty(this.__filter_data.to)) {
      searchOpts.date_to = this.__filter_data.to;
    }
    if (!CUI.util.isEmpty(this.__filter_data.user)) {
      searchOpts.user_id = this.__filter_data.user.user._id;
    }
    if (!CUI.util.isEmpty(this.__filter_data.groups)) {
      searchOpts.group_id = this.__filter_data.groups.join(",");
    }
    if (!CUI.util.isEmpty(this.__filter_data.userTypes)) {
      searchOpts.user_type = this.__filter_data.userTypes.join(",");
    }
    if (ez5.version("6.7") && !CUI.util.isEmpty(this.__filter_data.objecttype)) {
      searchOpts.objecttype = this.__filter_data.objecttype;
    }
    if (ez5.version("6.7") && !CUI.util.isEmpty(this.__filter_data.system_object_id)) {
      searchOpts.system_object_id = this.__filter_data.system_object_id;
    }
    if (this.__sort) {
      if (this.__sort.indexOf("_id.") === -1) {
        searchOpts.sort = this.__sort + ",_id.DESC";
      } else {
        searchOpts.sort = this.__sort;
      }
    }
    return searchOpts;
  };

  AdminEventManager.prototype.loadTree = function(refresh) {
    if (refresh == null) {
      refresh = false;
    }
    if (refresh) {
      return AdminEventManager.__super__.loadTree.call(this);
    } else {
      this.setStatus();
      return CUI.resolvedPromise();
    }
  };

  AdminEventManager.prototype.getMoreButtons = function() {
    return [
      this.__csvButton = new LocaButtonHref({
        loca_key: "admin.event.manager.csv_download",
        disabled: true,
        onClick: (function(_this) {
          return function() {
            var data, form, modal;
            data = {
              csv_max_length: true,
              csv_explode_info: true
            };
            form = new CUI.Form({
              data: data,
              fields: [
                {
                  type: CUI.Checkbox,
                  name: "csv_explode_info",
                  form: {
                    label: $$("admin.event.manager.csv-download.form.explode_info.label")
                  }
                }, {
                  type: CUI.Checkbox,
                  name: "csv_max_length",
                  form: {
                    label: $$("admin.event.manager.csv-download.form.max_length.label")
                  }
                }
              ]
            });
            form.start();
            modal = new CUI.Modal({
              cancel: true,
              onCancel: function() {
                modal.destroy();
              },
              pane: {
                padded: true,
                header_left: new CUI.Label({
                  text: $$("admin.event.manager.csv-download.modal.header.label")
                }),
                content: form,
                footer_right: new LocaButton({
                  loca_key: "admin.event.manager.csv-download.modal.button",
                  onClick: function() {
                    var downloadUrl, opts;
                    opts = {
                      csv_max_length: data.csv_max_length ? 100 : 0,
                      csv_explode: data.csv_explode_info ? "true" : void 0
                    };
                    downloadUrl = _this.__getCSVDownloadURL(opts);
                    ez5.download_file({
                      href: downloadUrl
                    });
                    return modal.doCancel();
                  }
                })
              }
            });
            return modal.show();
          };
        })(this)
      }), ez5.session.hasSystemRight("root", "system.api.event.delete", "system.api.event[delete]") ? this.__deleteButton = new LocaButton({
        ui: "admin.event.manager-remove-from-server-button",
        loca_key: "admin.event.manager.remove_from_server",
        disabled: true,
        onClick: (function(_this) {
          return function() {
            return CUI.confirm({
              title: $$("admin.event.manager.remove_from_server_confirm.title"),
              button_text_ok: $$("admin.event.manager.remove_from_server_confirm.ok"),
              button_text_cancel: $$("admin.event.manager.remove_from_server_confirm.cancel"),
              text: $$("admin.event.manager.remove_from_server_confirm.text", {
                count: _this.__count
              })
            }).done(function() {
              return _this.__deleteAll();
            });
          };
        })(this)
      }) : void 0
    ];
  };

  AdminEventManager.prototype.__getCSVDownloadURL = function(_searchOpts) {
    var searchOpts, url;
    searchOpts = this.__getSearchOpts();
    delete searchOpts.limit;
    CUI.util.mergeMap(searchOpts, _searchOpts);
    searchOpts.format = "csv";
    searchOpts.csv_use_bom = "true";
    searchOpts.csv_explode_array_concat = ",";
    searchOpts.csv_delimiter = ";";
    searchOpts.offset = 0;
    url = ez5.api.getFullBase() + "/event/list?" + ez5.tokenParam + "=" + ez5.session.token + "&";
    url += CUI.encodeUrlData(searchOpts);
    return url;
  };

  AdminEventManager.prototype.__deleteAll = function() {
    var alert, deleteApiInvocation, deletedCount, doDelete, showSuccess;
    deleteApiInvocation = null;
    deletedCount = 0;
    alert = new CUI.Alert({
      text: $$("admin.event.manager.remove_loading.text"),
      text_icon: "spinner",
      button_text_ok: $$("admin.event.manager.remove_loading.abort-button")
    });
    alert.open().done((function(_this) {
      return function() {
        if (deleteApiInvocation != null) {
          deleteApiInvocation.abort();
        }
        alert.destroy();
        return showSuccess(deletedCount);
      };
    })(this));
    showSuccess = (function(_this) {
      return function(count) {
        return CUI.alert({
          text: $$("admin.event.manager.remove_from_server_confirm.done", {
            count: count
          })
        }).done(function() {
          return _this.__refresh();
        });
      };
    })(this);
    doDelete = (function(_this) {
      return function() {
        var api;
        if (_this.__newApi) {
          api = "/list";
        } else {
          api = "";
        }
        return deleteApiInvocation = ez5.api.event({
          type: "DELETE",
          api: api,
          data: _this.__getDeleteUrlData()
        }).done(function(data) {
          if (deletedCount >= _this.__count) {
            if (alert != null) {
              alert.destroy();
            }
            return showSuccess(deletedCount);
          } else {
            deletedCount += data.count;
            return doDelete();
          }
        }).fail(function() {
          if (alert != null) {
            alert.destroy();
          }
          return showSuccess(deletedCount);
        });
      };
    })(this);
    return doDelete();
  };

  AdminEventManager.prototype.__getDeleteUrlData = function() {
    var searchOpts;
    searchOpts = this.__getSearchOpts();
    delete searchOpts.limit;
    searchOpts.offset = 0;
    return searchOpts;
  };

  AdminEventManager.prototype.deleteRows = function(rows) {
    var i, ids, len, row;
    ids = [];
    for (i = 0, len = rows.length; i < len; i++) {
      row = rows[i];
      ids.push(row.getID());
    }
    return this.__deleteMultipleById(ids);
  };

  AdminEventManager.prototype.load = function() {
    var gridBody, label, loadPromise;
    if (ez5.session.hasSystemRight("root", "system.api.event.get", "system.api.event[get]")) {
      loadPromise = AdminEventManager.__super__.load.call(this);
      gridBody = this.__getTreeGridBody();
      if (gridBody) {
        new CUI.Lasso({
          element: gridBody,
          create: (function(_this) {
            return function(ev) {
              return ev.hasModifierKey(true);
            };
          })(this),
          dragstart: (function(_this) {
            return function() {
              var i, len, results, selectedRow, selectedRows;
              selectedRows = _this.tree.getSelectedRows();
              if (selectedRows.length > 0) {
                results = [];
                for (i = 0, len = selectedRows.length; i < len; i++) {
                  selectedRow = selectedRows[i];
                  results.push(selectedRow != null ? selectedRow.deselect(null) : void 0);
                }
                return results;
              }
            };
          })(this),
          selected: (function(_this) {
            return function(ev, info) {
              var element, i, len, listViewRow, ref;
              ref = info.elements;
              for (i = 0, len = ref.length; i < len; i++) {
                element = ref[i];
                listViewRow = CUI.dom.data(element, "listViewRow");
                if (listViewRow != null) {
                  listViewRow.select(ev);
                }
              }
              return true;
            };
          })(this)
        });
      }
      return loadPromise;
    } else {
      label = new CUI.Label({
        text: $$("admin.event.manager.no_rights"),
        multiline: true,
        centered: true,
        appearance: 'secondary'
      });
      ez5.rootLayout.replace(label, "center");
    }
    return CUI.resolvedPromise();
  };

  AdminEventManager.prototype.unload = function() {
    var gridBody;
    gridBody = this.__getTreeGridBody();
    if (gridBody) {
      CUI.Lasso.destroy(gridBody);
    }
    return AdminEventManager.__super__.unload.call(this);
  };

  AdminEventManager.prototype.__getTreeGridBody = function() {
    var grid, ref;
    grid = (ref = this.tree) != null ? ref.getBottom() : void 0;
    if (!grid) {
      return;
    }
    return CUI.dom.children(grid)[0];
  };

  AdminEventManager.prototype.__deleteMultipleById = function(ids) {
    var call;
    if (ids == null) {
      ids = [];
    }
    if (this.__newApi) {
      call = {
        type: "DELETE",
        api: "/list",
        data: {
          id: ids.join(",")
        }
      };
    } else {
      call = {
        type: "DELETE",
        json_data: ids
      };
    }
    return CUI.confirm({
      text: $$("admin.event.manager.remove_from_server_confirm.text", {
        count: ids.length
      })
    }).done((function(_this) {
      return function() {
        return ez5.api.event(call).done(function() {
          return CUI.alert({
            text: $$("admin.event.manager.remove_from_server_confirm.done", {
              count: ids.length
            })
          }).done(function() {
            if (!_this.__newApi && _this.__filter_data.id) {
              _this.__searchIdInput.setValue("");
              _this.__enableDisableFormFields(_this.__filter_data, _this.__searchIdInput);
            }
            return _this.__refresh();
          });
        });
      };
    })(this));
  };

  AdminEventManager.prototype.__enableDisableFormFields = function(data, input) {
    var field, i, len, ref, results;
    if (this.__newApi) {
      return;
    }
    ref = input.getForm().getFields();
    results = [];
    for (i = 0, len = ref.length; i < len; i++) {
      field = ref[i];
      if (field !== input) {
        if (data.id) {
          results.push(field.disable());
        } else {
          results.push(field.enable());
        }
      } else {
        results.push(void 0);
      }
    }
    return results;
  };

  AdminEventManager.prototype.getPlusButton = function() {};

  return AdminEventManager;

})(SystemListManager);

ez5.session_ready(function() {
  return ez5.rootMenu.registerApp(AdminEventManager);
});
